{
TGMRectangle demo program

  ES: programa de demostracin de uso del componente TGMRectangle
  EN: demo program use of component TGMRectangle

=========================================================================
History:

ver 0.1:
  ES- primera versin
  EN- first version
=========================================================================
IMPORTANTE PROGRAMADORES: Por favor, si tienes comentarios, mejoras,
  ampliaciones, errores y/o cualquier otro tipo de sugerencia, envame un correo a:
  gmlib@cadetill.com

IMPORTANT PROGRAMMERS: please, if you have comments, improvements, enlargements,
  errors and/or any another type of suggestion, please send me a mail to:
  gmlib@cadetill.com
=========================================================================

Copyright () 2012, by Xavier Martinez (cadetill)

@author Xavier Martinez (cadetill)
@web  http://www.cadetill.com
}
unit UGMRectangleFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, GMBase, GMMap, OleCtrls, SHDocVw, ExtCtrls, ComCtrls, Tabs,
  CheckLst, GMLatLngBounds, GMLatLng, GMConstants, Buttons, Spin, GMRectangle;

type
  TGMRectangleFrm = class(TForm)
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    Panel10: TPanel;
    mEvents: TMemo;
    Panel11: TPanel;
    wbWeb: TWebBrowser;
    Splitter1: TSplitter;
    GMMap1: TGMMap;
    bClearLog: TButton;
    pOptions: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    Panel12: TPanel;
    GroupBox1: TGroupBox;
    lLong: TLabel;
    lLat: TLabel;
    lTypMap: TLabel;
    lZoom: TLabel;
    eReqLng: TEdit;
    eReqLat: TEdit;
    cbTypMap: TComboBox;
    tbZoom: TTrackBar;
    GroupBox2: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    cbZoomClick: TCheckBox;
    cbDraggable: TCheckBox;
    cbKeyboard: TCheckBox;
    cbNoClear: TCheckBox;
    eMaxZoom: TEdit;
    eMinZoom: TEdit;
    cbWheel: TCheckBox;
    GroupBox3: TGroupBox;
    pPages: TPageControl;
    tsGeneral: TTabSheet;
    Panel2: TPanel;
    Label16: TLabel;
    cbBGColor: TColorBox;
    tsMapType: TTabSheet;
    Panel3: TPanel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    cbShowMapType: TCheckBox;
    cbMapTypePos: TComboBox;
    cbMapTypeStyle: TComboBox;
    cbMapType: TCheckListBox;
    tsOverview: TTabSheet;
    Panel4: TPanel;
    cbShowOver: TCheckBox;
    cbOverOpened: TCheckBox;
    tsPan: TTabSheet;
    Panel5: TPanel;
    Label18: TLabel;
    cbShowPan: TCheckBox;
    cbPanPos: TComboBox;
    tsRotate: TTabSheet;
    Panel6: TPanel;
    Label17: TLabel;
    cbRoratePos: TComboBox;
    cbShowRotate: TCheckBox;
    tsScale: TTabSheet;
    Panel7: TPanel;
    Label19: TLabel;
    Label20: TLabel;
    cbShowScale: TCheckBox;
    cbScalePos: TComboBox;
    cbScaleStyle: TComboBox;
    tsStreetView: TTabSheet;
    Panel8: TPanel;
    Label21: TLabel;
    cbStreetViewPos: TComboBox;
    cbShowStreetView: TCheckBox;
    tsZoom: TTabSheet;
    Panel9: TPanel;
    Label9: TLabel;
    Label10: TLabel;
    cbZoomPos: TComboBox;
    cbZoomStyle: TComboBox;
    cbShowZoom: TCheckBox;
    bDoWeb: TButton;
    Panel13: TPanel;
    Panel14: TPanel;
    Panel15: TPanel;
    gbB1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    eLatASW: TEdit;
    eLngASW: TEdit;
    eLatANE: TEdit;
    eLngANE: TEdit;
    gbLatLng: TGroupBox;
    Label14: TLabel;
    Label15: TLabel;
    eLat: TEdit;
    eLng: TEdit;
    Label22: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label23: TLabel;
    Button4: TButton;
    Label24: TLabel;
    Button5: TButton;
    Button6: TButton;
    Label25: TLabel;
    Button7: TButton;
    Button8: TButton;
    GroupBox4: TGroupBox;
    Label26: TLabel;
    Label27: TLabel;
    eLatMethod: TEdit;
    eLngMethod: TEdit;
    Button9: TButton;
    Button12: TButton;
    Button16: TButton;
    Label29: TLabel;
    Label28: TLabel;
    tbZoomMet: TTrackBar;
    cbMapTypeMet: TComboBox;
    Button11: TButton;
    Button10: TButton;
    Button14: TButton;
    Button13: TButton;
    GroupBox5: TGroupBox;
    Label30: TLabel;
    Label31: TLabel;
    eXMet: TEdit;
    eYMet: TEdit;
    Button15: TButton;
    GroupBox6: TGroupBox;
    cbBoundsChanged: TCheckBox;
    cbCenterChanged: TCheckBox;
    cbDblClick: TCheckBox;
    cbClick: TCheckBox;
    cbMapTypeIdChanged: TCheckBox;
    cbDragStart: TCheckBox;
    cbDragEnd: TCheckBox;
    cbDrag: TCheckBox;
    cbZoomChanged: TCheckBox;
    cbRightClick: TCheckBox;
    cbMouseOver: TCheckBox;
    cbMouseOut: TCheckBox;
    cbMouseMove: TCheckBox;
    TabSheet5: TTabSheet;
    Panel16: TPanel;
    Label32: TLabel;
    lLatEvent: TLabel;
    lLngEvent: TLabel;
    Label34: TLabel;
    TabSheet6: TTabSheet;
    Panel17: TPanel;
    GroupBox7: TGroupBox;
    Label33: TLabel;
    Label35: TLabel;
    eInterval: TEdit;
    cbLanguages: TComboBox;
    bEdit: TBitBtn;
    bDel: TBitBtn;
    lbRectangles: TListBox;
    bUp: TButton;
    bDown: TButton;
    lZIndex: TLabel;
    bCenterAt: TButton;
    Label40: TLabel;
    ePrecision: TSpinEdit;
    cbActive: TCheckBox;
    bNew: TBitBtn;
    GMRectangle1: TGMRectangle;
    bPrint: TButton;
    bPreview: TButton;
    bSave: TButton;
    procedure bDoWebClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure GMMap1AfterPageLoaded(Sender: TObject; First: Boolean);
    procedure StatusBar1DrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel;
      const Rect: TRect);
    procedure StatusBar1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure StatusBar1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button9Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure GMMap1BoundsChanged(Sender: TObject; NewBounds: TLatLngBounds);
    procedure GMMap1CenterChanged(Sender: TObject; LatLng: TLatLng);
    procedure GMMap1Click(Sender: TObject; LatLng: TLatLng);
    procedure GMMap1DblClick(Sender: TObject; LatLng: TLatLng);
    procedure GMMap1Drag(Sender: TObject);
    procedure GMMap1DragEnd(Sender: TObject);
    procedure GMMap1DragStart(Sender: TObject);
    procedure GMMap1MapTypeIdChanged(Sender: TObject; NewMapTypeId: TMapTypeId);
    procedure GMMap1MouseMove(Sender: TObject; LatLng: TLatLng);
    procedure GMMap1MouseOut(Sender: TObject; LatLng: TLatLng);
    procedure GMMap1MouseOver(Sender: TObject; LatLng: TLatLng);
    procedure GMMap1RightClick(Sender: TObject; LatLng: TLatLng);
    procedure GMMap1ZoomChanged(Sender: TObject; NewZoom: Integer);
    procedure cbBoundsChangedClick(Sender: TObject);
    procedure cbCenterChangedClick(Sender: TObject);
    procedure cbClickClick(Sender: TObject);
    procedure cbDblClickClick(Sender: TObject);
    procedure cbDragClick(Sender: TObject);
    procedure cbDragEndClick(Sender: TObject);
    procedure cbDragStartClick(Sender: TObject);
    procedure cbMapTypeIdChangedClick(Sender: TObject);
    procedure cbMouseMoveClick(Sender: TObject);
    procedure cbMouseOutClick(Sender: TObject);
    procedure cbMouseOverClick(Sender: TObject);
    procedure cbRightClickClick(Sender: TObject);
    procedure cbZoomChangedClick(Sender: TObject);
    procedure bClearLogClick(Sender: TObject);
    procedure eIntervalChange(Sender: TObject);
    procedure cbLanguagesChange(Sender: TObject);
    procedure bUpClick(Sender: TObject);
    procedure bDownClick(Sender: TObject);
    procedure bEditClick(Sender: TObject);
    procedure bDelClick(Sender: TObject);
    procedure ePrecisionChange(Sender: TObject);
    procedure cbActiveClick(Sender: TObject);
    procedure GMPolygon1DblClick(Sender: TObject; LatLng: TLatLng;
      Index: Integer; LinkedComponent: TLinkedComponent);
    procedure GMPolygon1MouseDown(Sender: TObject; LatLng: TLatLng;
      Index: Integer; LinkedComponent: TLinkedComponent);
    procedure GMPolygon1MouseMove(Sender: TObject; LatLng: TLatLng;
      Index: Integer; LinkedComponent: TLinkedComponent);
    procedure GMPolygon1MouseOut(Sender: TObject; LatLng: TLatLng;
      Index: Integer; LinkedComponent: TLinkedComponent);
    procedure GMPolygon1MouseOver(Sender: TObject; LatLng: TLatLng;
      Index: Integer; LinkedComponent: TLinkedComponent);
    procedure GMPolygon1MouseUp(Sender: TObject; LatLng: TLatLng;
      Index: Integer; LinkedComponent: TLinkedComponent);
    procedure GMPolygon1RightClick(Sender: TObject; LatLng: TLatLng;
      Index: Integer; LinkedComponent: TLinkedComponent);
    procedure bCenterAtClick(Sender: TObject);
    procedure lbRectanglesDblClick(Sender: TObject);
    procedure bNewClick(Sender: TObject);
    procedure GMRectangle1Click(Sender: TObject; LatLng: TLatLng;
      Index: Integer; LinkedComponent: TLinkedComponent);
    procedure GMRectangle1BoundsChanged(Sender: TObject; Index: Integer;
      LinkedComponent: TLinkedComponent);
    procedure GMRectangle1ClickableChange(Sender: TObject; Index: Integer;
      LinkedComponent: TLinkedComponent);
    procedure GMRectangle1CloseClick(Sender: TObject; Index: Integer;
      LinkedComponent: TLinkedComponent);
    procedure GMRectangle1CloseOtherBeforeOpenChange(Sender: TObject;
      Index: Integer; LinkedComponent: TLinkedComponent);
    procedure GMRectangle1StrokeColorChange(Sender: TObject; Index: Integer;
      LinkedComponent: TLinkedComponent);
    procedure GMRectangle1StrokeOpacityChange(Sender: TObject; Index: Integer;
      LinkedComponent: TLinkedComponent);
    procedure GMRectangle1StrokeWeightChange(Sender: TObject; Index: Integer;
      LinkedComponent: TLinkedComponent);
    procedure GMRectangle1FillColorChange(Sender: TObject; Index: Integer;
      LinkedComponent: TLinkedComponent);
    procedure GMRectangle1FillOpacityChange(Sender: TObject; Index: Integer;
      LinkedComponent: TLinkedComponent);
    procedure GMRectangle1VisibleChange(Sender: TObject; Index: Integer;
      LinkedComponent: TLinkedComponent);
    procedure GMRectangle1EditableChange(Sender: TObject; Index: Integer;
      LinkedComponent: TLinkedComponent);
    procedure bPreviewClick(Sender: TObject);
    procedure bSaveClick(Sender: TObject);
    procedure bPrintClick(Sender: TObject);
  private
    procedure ShowRectangles;
    procedure DoMap;
  public
    constructor Create(aOwner: TComponent); override;
  end;

var
  GMRectangleFrm: TGMRectangleFrm;

implementation

uses
  ShellAPI, URectangleFrm;

function GetStatusBarPanelXY(StatusBar : TStatusBar; X, Y: Integer) : Integer;
var
  i: Integer;
  R: TRect;
begin
  Result := -1;

  // Buscamos panel a panel hasta encontrar en cual est XY
  with StatusBar do
    for i := 0 to Panels.Count - 1 do
    begin
      // Obtenemos las dimensiones del panel
      SendMessage(Handle, WM_USER + 10, i, Integer(@R));
      if PtInRect(R, Point(x,y)) then
      begin
        Result := i;
        Break;
      end;
    end;
end;

{$R *.dfm}

procedure TGMRectangleFrm.bEditClick(Sender: TObject);
var
  Rec: TRectangle;
  PFrm: TRectangleFrm;
begin
  if lbRectangles.ItemIndex = -1 then
    Rec := GMRectangle1.Add
  else
    Rec := GMRectangle1[lbRectangles.ItemIndex];

  PFrm := TRectangleFrm.Create(Self, GMRectangle1, Rec.Index);
  try
    PFrm.ShowModal;
  finally
    FreeAndNil(PFrm);
  end;
end;

procedure TGMRectangleFrm.bCenterAtClick(Sender: TObject);
begin
  if lbRectangles.ItemIndex = -1 then Exit;

  GMRectangle1[lbRectangles.ItemIndex].CenterMapTo;
end;

procedure TGMRectangleFrm.bClearLogClick(Sender: TObject);
begin
  mEvents.Clear;
end;

procedure TGMRectangleFrm.bDelClick(Sender: TObject);
begin
  if lbRectangles.ItemIndex = -1 then Exit;

  GMRectangle1.Delete(lbRectangles.ItemIndex);
  lbRectangles.DeleteSelected;

  ShowRectangles;
end;

procedure TGMRectangleFrm.bDoWebClick(Sender: TObject);
begin
  DoMap;
end;

procedure TGMRectangleFrm.bDownClick(Sender: TObject);
begin
  if lbRectangles.ItemIndex = -1 then Exit;
  if lbRectangles.ItemIndex = lbRectangles.Count - 1 then Exit;

  GMRectangle1.Move(lbRectangles.ItemIndex, lbRectangles.ItemIndex+1);
  lbRectangles.Items.Move(lbRectangles.ItemIndex, lbRectangles.ItemIndex+1);

  ShowRectangles;
end;

procedure TGMRectangleFrm.bNewClick(Sender: TObject);
var
  Rec: TRectangle;
  PFrm: TRectangleFrm;
begin
  Rec := GMRectangle1.Add;

  PFrm := TRectangleFrm.Create(Self, GMRectangle1, Rec.Index);
  try
    PFrm.ShowModal;
  finally
    FreeAndNil(PFrm);
  end;
end;

procedure TGMRectangleFrm.bPreviewClick(Sender: TObject);
begin
  GMMap1.PrintPreview;
end;

procedure TGMRectangleFrm.bPrintClick(Sender: TObject);
begin
  GMMap1.PrintWithDialog;
end;

procedure TGMRectangleFrm.bSaveClick(Sender: TObject);
begin
  GMMap1.SaveToJPGFile;
end;

procedure TGMRectangleFrm.bUpClick(Sender: TObject);
begin
  if lbRectangles.ItemIndex = -1 then Exit;
  if lbRectangles.ItemIndex = 0 then Exit;

  GMRectangle1.Move(lbRectangles.ItemIndex, lbRectangles.ItemIndex-1);
  lbRectangles.Items.Move(lbRectangles.ItemIndex, lbRectangles.ItemIndex-1);

  ShowRectangles;
end;

procedure TGMRectangleFrm.Button10Click(Sender: TObject);
begin
  GMMap1.SetMapTypeId(cbMapTypeMet.Text);
end;

procedure TGMRectangleFrm.Button11Click(Sender: TObject);
begin
  cbMapTypeMet.ItemIndex := cbMapTypeMet.Items.IndexOf(GMMap1.MapTypeIdToStr(GMMap1.GetMapTypeId));
end;

procedure TGMRectangleFrm.Button12Click(Sender: TObject);
begin
  GMMap1.SetCenter(StrToFloat(StringReplace(eLatMethod.Text, '.', ',', [rfReplaceAll])),
                   StrToFloat(StringReplace(eLngMethod.Text, '.', ',', [rfReplaceAll])));
end;

procedure TGMRectangleFrm.Button13Click(Sender: TObject);
begin
  tbZoomMet.Position := GMMap1.GetZoom;
end;

procedure TGMRectangleFrm.Button14Click(Sender: TObject);
begin
  GMMap1.SetZoom(tbZoomMet.Position);
end;

procedure TGMRectangleFrm.Button15Click(Sender: TObject);
begin
  GMMap1.PanBy(StrToInt(eXMet.Text), StrToInt(eYMet.Text));
end;

procedure TGMRectangleFrm.Button16Click(Sender: TObject);
begin
  GMMap1.PanTo(StrToFloat(StringReplace(eLatMethod.Text, '.', ',', [rfReplaceAll])),
               StrToFloat(StringReplace(eLngMethod.Text, '.', ',', [rfReplaceAll])));
end;

procedure TGMRectangleFrm.Button1Click(Sender: TObject);
var
  Bounds: TLatLngBounds;
begin
  Bounds := GMMap1.LatLngBoundsGetBounds;
  eLatASW.Text := Bounds.SW.LatToStr(GMMap1.Precision);
  eLngASW.Text := Bounds.SW.LngToStr(GMMap1.Precision);
  eLatANE.Text := Bounds.NE.LatToStr(GMMap1.Precision);
  eLngANE.Text := Bounds.NE.LngToStr(GMMap1.Precision);
end;

procedure TGMRectangleFrm.Button2Click(Sender: TObject);
begin
  GMMap1.LatLngBoundsSetBounds(
                    StrToFloat(StringReplace(eLatASW.Text, '.', ',', [rfReplaceAll])),
                    StrToFloat(StringReplace(eLngASW.Text, '.', ',', [rfReplaceAll])),
                    StrToFloat(StringReplace(eLatANE.Text, '.', ',', [rfReplaceAll])),
                    StrToFloat(StringReplace(eLngANE.Text, '.', ',', [rfReplaceAll])));
end;

procedure TGMRectangleFrm.Button3Click(Sender: TObject);
begin
  ShowMessage(BoolToStr(GMMap1.LatLngBoundsContains(
                StrToFloat(StringReplace(eLat.Text, '.', ',', [rfReplaceAll])),
                StrToFloat(StringReplace(eLng.Text, '.', ',', [rfReplaceAll]))), True));
end;

procedure TGMRectangleFrm.Button4Click(Sender: TObject);
var
  Bounds: TLatLngBounds;
begin
  Bounds := GMMap1.LatLngBoundsExtend(
                    StrToFloat(StringReplace(eLat.Text, '.', ',', [rfReplaceAll])),
                    StrToFloat(StringReplace(eLng.Text, '.', ',', [rfReplaceAll])));

  eLatASW.Text := Bounds.SW.LatToStr(GMMap1.Precision);
  eLngASW.Text := Bounds.SW.LngToStr(GMMap1.Precision);
  eLatANE.Text := Bounds.NE.LatToStr(GMMap1.Precision);
  eLngANE.Text := Bounds.NE.LngToStr(GMMap1.Precision);
end;

procedure TGMRectangleFrm.Button5Click(Sender: TObject);
begin
  eLat.Text := GMMap1.LatLngBoundsGetCenter.LatToStr(GMMap1.Precision);
  eLng.Text := GMMap1.LatLngBoundsGetCenter.LngToStr(GMMap1.Precision);
end;

procedure TGMRectangleFrm.Button6Click(Sender: TObject);
begin
  eLat.Text := GMMap1.LatLngBoundsToSpan.LatToStr(GMMap1.Precision);
  eLng.Text := GMMap1.LatLngBoundsToSpan.LngToStr(GMMap1.Precision);
end;

procedure TGMRectangleFrm.Button7Click(Sender: TObject);
begin
  ShowMessage(GMMap1.LatLngBoundsGetBounds.ToStr(GMMap1.Precision));
end;

procedure TGMRectangleFrm.Button8Click(Sender: TObject);
begin
  ShowMessage(GMMap1.LatLngBoundsGetBounds.ToUrlValue(GMMap1.Precision));
end;

procedure TGMRectangleFrm.Button9Click(Sender: TObject);
begin
  eLatMethod.Text := GMMap1.GetCenter.LatToStr(GMMap1.Precision);
  eLngMethod.Text := GMMap1.GetCenter.LngToStr(GMMap1.Precision);
end;

procedure TGMRectangleFrm.cbActiveClick(Sender: TObject);
begin
  GMMap1.Active := cbActive.Checked;
end;

procedure TGMRectangleFrm.cbBoundsChangedClick(Sender: TObject);
begin
  GMMap1.OnBoundsChanged := nil;
  if cbBoundsChanged.Checked then
    GMMap1.OnBoundsChanged := GMMap1BoundsChanged;
end;

procedure TGMRectangleFrm.cbCenterChangedClick(Sender: TObject);
begin
  GMMap1.OnCenterChanged := nil;
  if cbCenterChanged.Checked then
    GMMap1.OnCenterChanged := GMMap1CenterChanged;
end;

procedure TGMRectangleFrm.cbClickClick(Sender: TObject);
begin
  GMMap1.OnClick := nil;
  if cbClick.Checked then
    GMMap1.OnClick := GMMap1Click;
end;

procedure TGMRectangleFrm.cbDblClickClick(Sender: TObject);
begin
  GMMap1.OnDblClick := nil;
  if cbDblClick.Checked then
    GMMap1.OnDblClick := GMMap1DblClick;
end;

procedure TGMRectangleFrm.cbDragClick(Sender: TObject);
begin
  GMMap1.OnDrag := nil;
  if cbDrag.Checked then
    GMMap1.OnDrag := GMMap1Drag;
end;

procedure TGMRectangleFrm.cbDragEndClick(Sender: TObject);
begin
  GMMap1.OnDragEnd := nil;
  if cbDragEnd.Checked then
    GMMap1.OnDragEnd := GMMap1DragEnd;
end;

procedure TGMRectangleFrm.cbDragStartClick(Sender: TObject);
begin
  GMMap1.OnDragStart := nil;
  if cbDragStart.Checked then
    GMMap1.OnDragStart := GMMap1DragStart;
end;

procedure TGMRectangleFrm.cbLanguagesChange(Sender: TObject);
begin
  case cbLanguages.ItemIndex of
    0: GMMap1.Language := Espanol;
    1: GMMap1.Language := English;
  end;
end;

procedure TGMRectangleFrm.cbMapTypeIdChangedClick(Sender: TObject);
begin
  GMMap1.OnMapTypeIdChanged := nil;
  if cbMapTypeIdChanged.Checked then
    GMMap1.OnMapTypeIdChanged := GMMap1MapTypeIdChanged;
end;

procedure TGMRectangleFrm.cbMouseMoveClick(Sender: TObject);
begin
  GMMap1.OnMouseMove := nil;
  if cbMouseMove.Checked then
    GMMap1.OnMouseMove := GMMap1MouseMove;
end;

procedure TGMRectangleFrm.cbMouseOutClick(Sender: TObject);
begin
  GMMap1.OnMouseOut := nil;
  if cbMouseOut.Checked then
    GMMap1.OnMouseOut := GMMap1MouseOut;
end;

procedure TGMRectangleFrm.cbMouseOverClick(Sender: TObject);
begin
  GMMap1.OnMouseOver := nil;
  if cbMouseOver.Checked then
    GMMap1.OnMouseOver := GMMap1MouseOver;
end;

procedure TGMRectangleFrm.cbRightClickClick(Sender: TObject);
begin
  GMMap1.OnRightClick := nil;
  if cbRightClick.Checked then
    GMMap1.OnRightClick := GMMap1RightClick;
end;

procedure TGMRectangleFrm.cbZoomChangedClick(Sender: TObject);
begin
  GMMap1.OnZoomChanged := nil;
  if cbZoomChanged.Checked then
    GMMap1.OnZoomChanged := GMMap1ZoomChanged;
end;

constructor TGMRectangleFrm.Create(aOwner: TComponent);
begin
  inherited;

  ShowRectangles;

  case GMMap1.Language of
    Espanol: cbLanguages.ItemIndex := 0;
    English: cbLanguages.ItemIndex := 1;
  end;
  eInterval.Text := IntToStr(GMMap1.IntervalEvents);
  bDoWeb.Enabled := False;
  GMMap1.Active := True;
  pPages.ActivePageIndex := 0;
  pOptions.ActivePageIndex := 0;
  ePrecision.Value := GMMap1.Precision;
  cbMapType.CheckAll(cbChecked);
  mEvents.Clear;
  cbActive.Checked := GMMap1.Active;
end;

procedure TGMRectangleFrm.DoMap;
begin
  // required properties
  GMMap1.RequiredProp.Center.Lat := StrToFloat(eReqLat.Text);
  GMMap1.RequiredProp.Center.Lng := StrToFloat(eReqLng.Text);
  GMMap1.RequiredProp.MapType := GMMap1.StrToMapTypeId(cbTypMap.Text);
  GMMap1.RequiredProp.Zoom := tbZoom.Position;

  // non visual properties
  with GMMap1.NonVisualProp do
  begin
    MaxZoom := StrToInt(eMaxZoom.Text);
    MinZoom := StrToInt(eMinZoom.Text);
    Options := [];
    if cbZoomClick.Checked then Options := Options + [DisableDoubleClickZoom];
    if cbDraggable.Checked then Options := Options + [Draggable];
    if cbKeyboard.Checked then Options := Options + [KeyboardShortcuts];
    if cbNoClear.Checked then Options := Options + [NoClear];
    if cbWheel.Checked then Options := Options + [ScrollWheel];
  end;

  // visual properties
  with GMMap1.VisualProp do
  begin
    BGColor := cbBGColor.Selected;

    MapTypeCtrl.Show := cbShowMapType.Checked;
    MapTypeCtrl.Position := GMMap1.StrToPosition(cbMapTypePos.Text);
    MapTypeCtrl.Style := GMMap1.StrToMapTypeControlStyle(cbMapTypeStyle.Text);
    MapTypeCtrl.MapTypeIds := [];
    if cbMapType.Checked[0] then MapTypeCtrl.MapTypeIds := MapTypeCtrl.MapTypeIds + [mtHYBRID];
    if cbMapType.Checked[1] then MapTypeCtrl.MapTypeIds := MapTypeCtrl.MapTypeIds + [mtROADMAP];
    if cbMapType.Checked[2] then MapTypeCtrl.MapTypeIds := MapTypeCtrl.MapTypeIds + [mtSATELLITE];
    if cbMapType.Checked[3] then MapTypeCtrl.MapTypeIds := MapTypeCtrl.MapTypeIds + [mtTERRAIN];

    OverviewMapCtrl.Show := cbShowOver.Checked;
    OverviewMapCtrl.Opened := cbOverOpened.Checked;

    PanCtrl.Show := cbShowPan.Checked;
    PanCtrl.Position := GMMap1.StrToPosition(cbPanPos.Text);

    RotateCtrl.Show := cbShowRotate.Checked;
    RotateCtrl.Position := GMMap1.StrToPosition(cbRoratePos.Text);

    ScaleCtrl.Show := cbShowScale.Checked;
    ScaleCtrl.Position := GMMap1.StrToPosition(cbScalePos.Text);
    ScaleCtrl.Style := GMMap1.StrToScaleControlStyle(cbScaleStyle.Text);

    StreetViewCtrl.Show := cbShowStreetView.Checked;
    StreetViewCtrl.Position := GMMap1.StrToPosition(cbStreetViewPos.Text);

    ZoomCtrl.Show := cbShowZoom.Checked;
    ZoomCtrl.Position := GMMap1.StrToPosition(cbZoomPos.Text);
    ZoomCtrl.Style := GMMap1.StrToZoomControlStyle(cbZoomStyle.Text);
  end;

  // do map
  GMMap1.DoMap;
end;

procedure TGMRectangleFrm.eIntervalChange(Sender: TObject);
var
  Temp: Integer;
begin
  if TryStrToInt(eInterval.Text, Temp) then
    GMMap1.IntervalEvents := Temp;
end;

procedure TGMRectangleFrm.GMMap1AfterPageLoaded(Sender: TObject; First: Boolean);
begin
  bDoWeb.Enabled := True;
  if First then
  begin
    mEvents.Lines.Add('AfterPageLoaded fired - first page loaded');
    DoMap;
  end
  else
    mEvents.Lines.Add('AfterPageLoaded fired - all tiles loaded');
end;

procedure TGMRectangleFrm.GMMap1BoundsChanged(Sender: TObject;
  NewBounds: TLatLngBounds);
const
  Str = 'OnBoundChanged fired - SW.Lat: %s, SW.Lng: %s, NE.Lat: %s, NE.Lng: %s';
begin
  mEvents.Lines.Add(Format(Str, [
        NewBounds.SW.LatToStr(GMMap1.Precision),
        NewBounds.SW.LngToStr(GMMap1.Precision),
        NewBounds.NE.LatToStr(GMMap1.Precision),
        NewBounds.NE.LngToStr(GMMap1.Precision)
        ]))
end;

procedure TGMRectangleFrm.GMMap1CenterChanged(Sender: TObject; LatLng: TLatLng);
const
  Str = 'OnCenterChanged fired - Lat: %s, Lng: %s';
begin
  mEvents.Lines.Add(Format(Str, [LatLng.LatToStr(GMMap1.Precision), LatLng.LngToStr(GMMap1.Precision)]));
end;

procedure TGMRectangleFrm.GMMap1Click(Sender: TObject; LatLng: TLatLng);
const
  Str = 'OnClick fired - Lat: %s, Lng: %s';
begin
  mEvents.Lines.Add(Format(Str, [LatLng.LatToStr(GMMap1.Precision), LatLng.LngToStr(GMMap1.Precision)]));
end;

procedure TGMRectangleFrm.GMMap1DblClick(Sender: TObject; LatLng: TLatLng);
const
  Str = 'OnDblClick fired - Lat: %s, Lng: %s';
begin
  mEvents.Lines.Add(Format(Str, [LatLng.LatToStr(GMMap1.Precision), LatLng.LngToStr(GMMap1.Precision)]));
end;

procedure TGMRectangleFrm.GMMap1Drag(Sender: TObject);
begin
  mEvents.Lines.Add('OnDrag fired');
end;

procedure TGMRectangleFrm.GMMap1DragEnd(Sender: TObject);
begin
  mEvents.Lines.Add('OnDragEnd fired');
end;

procedure TGMRectangleFrm.GMMap1DragStart(Sender: TObject);
begin
  mEvents.Lines.Add('OnDragStart fired');
end;

procedure TGMRectangleFrm.GMMap1MapTypeIdChanged(Sender: TObject;
  NewMapTypeId: TMapTypeId);
const
  Str = 'OnMapeTypeIdChanged fired - New MapTypeId: %s';
var
  Strg: string;
begin
  Strg := GMMap1.MapTypeIdToStr(NewMapTypeId);
  mEvents.Lines.Add(Format(Str, [Strg]));
  cbMapTypeMet.ItemIndex := cbMapTypeMet.Items.IndexOf(Strg);
  cbTypMap.ItemIndex := cbTypMap.Items.IndexOf(Strg);
end;

procedure TGMRectangleFrm.GMMap1MouseMove(Sender: TObject; LatLng: TLatLng);
begin
  lLatEvent.Caption := LatLng.LatToStr(GMMap1.Precision);
  lLngEvent.Caption := LatLng.LngToStr(GMMap1.Precision);
end;

procedure TGMRectangleFrm.GMMap1MouseOut(Sender: TObject; LatLng: TLatLng);
const
  Str = 'OnMouseOut fired - Lat: %s, Lng: %s';
begin
  mEvents.Lines.Add(Format(Str, [LatLng.LatToStr(GMMap1.Precision), LatLng.LngToStr(GMMap1.Precision)]));
end;

procedure TGMRectangleFrm.GMMap1MouseOver(Sender: TObject; LatLng: TLatLng);
const
  Str = 'OnMouseOver fired - Lat: %s, Lng: %s';
begin
  mEvents.Lines.Add(Format(Str, [LatLng.LatToStr(GMMap1.Precision), LatLng.LngToStr(GMMap1.Precision)]));
end;

procedure TGMRectangleFrm.GMMap1RightClick(Sender: TObject; LatLng: TLatLng);
const
  Str = 'OnRightClick fired - Lat: %s, Lng: %s';
begin
  mEvents.Lines.Add(Format(Str, [LatLng.LatToStr(GMMap1.Precision), LatLng.LngToStr(GMMap1.Precision)]));
end;

procedure TGMRectangleFrm.GMMap1ZoomChanged(Sender: TObject; NewZoom: Integer);
const
  Str = 'OnZoomChanged fired - New zoom: %d';
begin
  mEvents.Lines.Add(Format(Str, [NewZoom]));
  tbZoom.Position := NewZoom;
  tbZoomMet.Position := NewZoom;
end;

procedure TGMRectangleFrm.GMPolygon1DblClick(Sender: TObject; LatLng: TLatLng;
  Index: Integer; LinkedComponent: TLinkedComponent);
const
  Str = 'OnPolygonDblClick fired - Lat: %s, Lng: %s';
begin
  mEvents.Lines.Add(Format(Str, [LatLng.LatToStr(GMMap1.Precision), LatLng.LngToStr(GMMap1.Precision)]));
end;

procedure TGMRectangleFrm.GMPolygon1MouseDown(Sender: TObject; LatLng: TLatLng;
  Index: Integer; LinkedComponent: TLinkedComponent);
const
  Str = 'OnPolygonMouseDown fired - Lat: %s, Lng: %s';
begin
  mEvents.Lines.Add(Format(Str, [LatLng.LatToStr(GMMap1.Precision), LatLng.LngToStr(GMMap1.Precision)]));
end;

procedure TGMRectangleFrm.GMPolygon1MouseMove(Sender: TObject; LatLng: TLatLng;
  Index: Integer; LinkedComponent: TLinkedComponent);
const
  Str = 'OnPolygonMouseMove fired - Lat: %s, Lng: %s';
begin
  mEvents.Lines.Add(Format(Str, [LatLng.LatToStr(GMMap1.Precision), LatLng.LngToStr(GMMap1.Precision)]));
end;

procedure TGMRectangleFrm.GMPolygon1MouseOut(Sender: TObject; LatLng: TLatLng;
  Index: Integer; LinkedComponent: TLinkedComponent);
const
  Str = 'OnPolygonMouseOut fired - Lat: %s, Lng: %s';
begin
  mEvents.Lines.Add(Format(Str, [LatLng.LatToStr(GMMap1.Precision), LatLng.LngToStr(GMMap1.Precision)]));
end;

procedure TGMRectangleFrm.GMPolygon1MouseOver(Sender: TObject; LatLng: TLatLng;
  Index: Integer; LinkedComponent: TLinkedComponent);
const
  Str = 'OnPolygonMouseOver fired - Lat: %s, Lng: %s';
begin
  mEvents.Lines.Add(Format(Str, [LatLng.LatToStr(GMMap1.Precision), LatLng.LngToStr(GMMap1.Precision)]));
end;

procedure TGMRectangleFrm.GMPolygon1MouseUp(Sender: TObject; LatLng: TLatLng;
  Index: Integer; LinkedComponent: TLinkedComponent);
const
  Str = 'OnPolygonMouseUp fired - Lat: %s, Lng: %s';
begin
  mEvents.Lines.Add(Format(Str, [LatLng.LatToStr(GMMap1.Precision), LatLng.LngToStr(GMMap1.Precision)]));
end;

procedure TGMRectangleFrm.GMPolygon1RightClick(Sender: TObject; LatLng: TLatLng;
  Index: Integer; LinkedComponent: TLinkedComponent);
const
  Str = 'OnPolygonRightClick fired - Lat: %s, Lng: %s';
begin
  mEvents.Lines.Add(Format(Str, [LatLng.LatToStr(GMMap1.Precision), LatLng.LngToStr(GMMap1.Precision)]));
end;

procedure TGMRectangleFrm.GMRectangle1BoundsChanged(Sender: TObject;
  Index: Integer; LinkedComponent: TLinkedComponent);
const
  Str = 'OnBoundsChanged fired - NE: %s - SW: %s';
begin
  mEvents.Lines.Add(Format(Str,
                           [TRectangle(LinkedComponent).Bounds.NE.ToStr(GMMap1.Precision),
                            TRectangle(LinkedComponent).Bounds.SW.ToStr(GMMap1.Precision)]));
end;

procedure TGMRectangleFrm.GMRectangle1Click(Sender: TObject; LatLng: TLatLng;
  Index: Integer; LinkedComponent: TLinkedComponent);
const
  Str = 'OnRectangleClick fired - Lat: %s, Lng: %s';
  HTML = '<b>Rectangle Polygon</b><br />Clicked Location: <br />%s<br />';
begin
  mEvents.Lines.Add(Format(Str, [LatLng.LatToStr(GMMap1.Precision), LatLng.LngToStr(GMMap1.Precision)]));
  TRectangle(LinkedComponent).InfoWindow.HTMLContent := Format(HTML, [LatLng.ToUrlValue(GMMap1.Precision)]);
  TRectangle(LinkedComponent).InfoWindow.HTMLContent :=
    TRectangle(LinkedComponent).InfoWindow.HTMLContent +
      Format('<br />Coordinate NE: <br />%s<br />Coordinate SW: <br />%s',
             [TRectangle(LinkedComponent).Bounds.NE.ToUrlValue(GMMap1.Precision),
              TRectangle(LinkedComponent).Bounds.SW.ToUrlValue(GMMap1.Precision)]);
end;

procedure TGMRectangleFrm.GMRectangle1ClickableChange(Sender: TObject;
  Index: Integer; LinkedComponent: TLinkedComponent);
const
  Str = 'OnClickableChange fired';
begin
  mEvents.Lines.Add(Str);
end;

procedure TGMRectangleFrm.GMRectangle1CloseClick(Sender: TObject;
  Index: Integer; LinkedComponent: TLinkedComponent);
const
  Str = 'OnCloseClick fired - Content: %s';
begin
  mEvents.Lines.Add(Format(Str, [Copy(TRectangle(LinkedComponent).InfoWindow.HTMLContent, 1, 20)]));
end;

procedure TGMRectangleFrm.GMRectangle1CloseOtherBeforeOpenChange(
  Sender: TObject; Index: Integer; LinkedComponent: TLinkedComponent);
const
  Str = 'OnCloseOtherBeforeOpenChange fired - Content: %s';
begin
  mEvents.Lines.Add(Format(Str, [Copy(TRectangle(LinkedComponent).InfoWindow.HTMLContent, 1, 20)]));
end;

procedure TGMRectangleFrm.GMRectangle1EditableChange(Sender: TObject;
  Index: Integer; LinkedComponent: TLinkedComponent);
const
  Str = 'OnEditableChange fired';
begin
  mEvents.Lines.Add(Str);
end;

procedure TGMRectangleFrm.GMRectangle1FillColorChange(Sender: TObject;
  Index: Integer; LinkedComponent: TLinkedComponent);
const
  Str = 'OnFillColorChange fired - NewColor: %s';
begin
  mEvents.Lines.Add(Format(Str, [ColorToString(TRectangle(LinkedComponent).FillColor)]));
end;

procedure TGMRectangleFrm.GMRectangle1FillOpacityChange(Sender: TObject;
  Index: Integer; LinkedComponent: TLinkedComponent);
const
  Str = 'OnFillOpacityChange fired - NewOpacity: %s';
begin
  mEvents.Lines.Add(Format(Str, [FloatToStr(TRectangle(LinkedComponent).FillOpacity)]));
end;

procedure TGMRectangleFrm.GMRectangle1StrokeColorChange(Sender: TObject;
  Index: Integer; LinkedComponent: TLinkedComponent);
const
  Str = 'OnStrokeColorChange fired - NewColor: %s';
begin
  mEvents.Lines.Add(Format(Str, [ColorToString(TRectangle(LinkedComponent).StrokeColor)]));
end;

procedure TGMRectangleFrm.GMRectangle1StrokeOpacityChange(Sender: TObject;
  Index: Integer; LinkedComponent: TLinkedComponent);
const
  Str = 'OnStrokeOpacityChange fired - NewOpacity: %s';
begin
  mEvents.Lines.Add(Format(Str, [FloatToStr(TRectangle(LinkedComponent).StrokeOpacity)]));
end;

procedure TGMRectangleFrm.GMRectangle1StrokeWeightChange(Sender: TObject;
  Index: Integer; LinkedComponent: TLinkedComponent);
const
  Str = 'OnStrokeWeightChange fired - NewWeight: %s';
begin
  mEvents.Lines.Add(Format(Str, [IntToStr(TRectangle(LinkedComponent).StrokeWeight)]));
end;

procedure TGMRectangleFrm.GMRectangle1VisibleChange(Sender: TObject;
  Index: Integer; LinkedComponent: TLinkedComponent);
const
  Str = 'OnVisibleChange fired';
begin
  mEvents.Lines.Add(Str);
end;

procedure TGMRectangleFrm.lbRectanglesDblClick(Sender: TObject);
var
  RFrm: TRectangleFrm;
begin
  if lbRectangles.ItemIndex = -1 then Exit;

  RFrm := TRectangleFrm.Create(Self, GMRectangle1, lbRectangles.ItemIndex);
  try
    RFrm.ShowModal;
  finally
    FreeAndNil(RFrm);
  end;

  ShowRectangles;
end;

procedure TGMRectangleFrm.ePrecisionChange(Sender: TObject);
begin
  GMMap1.Precision := ePrecision.Value;
end;

procedure TGMRectangleFrm.ShowRectangles;
var
  i: Integer;
begin
  lbRectangles.Clear;
  for i := 0 to GMRectangle1.VisualObjects.Count - 1 do
    lbRectangles.Items.Add('Rectangle ' + IntToStr(GMRectangle1[i].Index));
end;

procedure TGMRectangleFrm.StatusBar1DrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel;
  const Rect: TRect);
begin
  StatusBar.Canvas.Font.Color := clBlue;
  Statusbar.Canvas.TextRect(Rect, Rect.Left, Rect.Top, Panel.Text);
end;

procedure TGMRectangleFrm.StatusBar1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if GetStatusBarPanelXY(StatusBar1, X, Y) = 1 then
    StatusBar1.Cursor := crHandPoint
  else
    StatusBar1.Cursor := crDefault;
end;

procedure TGMRectangleFrm.StatusBar1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (GetStatusBarPanelXY(StatusBar1, X, Y) = 1) and (Button = mbLeft) then
    ShellExecute(Handle, 'open', 'http://www.cadetill.com', nil, nil, SW_SHOW);
end;

end.
